# synfig::ValueNode_Animated Struct Reference

`#include <valuenode_animated.h>`

Inheritance diagram for synfig::ValueNode_Animated:

List of all members.

## Public Types

typedef etl::handle < ValueNode_Animated > | Handle
typedef etl::handle< const ValueNode_Animated > | ConstHandle
typedef synfig::Waypoint | Waypoint
typedef synfig::WaypointList | WaypointList
typedef std::pair < WaypointList::iterator, bool > | findresult
typedef std::pair < WaypointList::const_iterator, bool > | const_findresult

## Public Member Functions

WaypointList & | waypoint_list ()
const WaypointList & | waypoint_list () const
virtual WaypointList::iterator | new_waypoint (Time t, ValueBase value)=0
virtual WaypointList::iterator | new_waypoint (Time t, ValueNode::Handle value_node)=0
Waypoint | new_waypoint_at_time (const Time &t) const
WaypointList::iterator | add (const Waypoint &x)
void | erase (const UniqueID &x)
findresult | find_uid (const UniqueID &x)
const_findresult | find_uid (const UniqueID &x) const
findresult | find_time (const Time &x)
const_findresult | find_time (const Time &x) const
WaypointList::iterator | find (const UniqueID &x)
WaypointList::const_iterator | find (const UniqueID &x) const
WaypointList::iterator | find (const Time &x)
WaypointList::const_iterator | find (const Time &x) const
WaypointList::iterator | find_next (const Time &x)
WaypointList::const_iterator | find_next (const Time &x) const
WaypointList::iterator | find_prev (const Time &x)
WaypointList::const_iterator | find_prev (const Time &x) const
virtual | ~ValueNode_Animated ()
virtual String | get_name () const
| Returns the name of the ValueNode type.
virtual String | get_local_name () const
| Returns the localized name of the ValueNode type.
int | find (const Time &begin, const Time &end, std::vector< Waypoint * > &list)
void | insert_time (const Time &location, const Time &delta)
| DCAST_HACK_ID (4)

## Static Public Member Functions

static Handle | create (ValueBase::Type type)
static Handle | create (const ValueBase &value, const Time &time)
static Handle | create (ValueNode::Handle value_node, const Time &time)

## Protected Member Functions

| ValueNode_Animated ()
void | set_type (ValueBase::Type t)
| Sets the type of the ValueNode.
virtual void | get_times_vfunc (Node::time_set &set) const

## Protected Attributes

WaypointList | waypoint_list_

## Member Typedef Documentation

typedef etl::handle<ValueNode_Animated> synfig::ValueNode_Animated::Handle

Reimplemented from synfig::ValueNode.

typedef etl::handle<const ValueNode_Animated> synfig::ValueNode_Animated::ConstHandle

Reimplemented from synfig::ValueNode.

typedef synfig::Waypoint synfig::ValueNode_Animated::Waypoint

typedef synfig::WaypointList synfig::ValueNode_Animated::WaypointList

typedef std::pair<WaypointList::iterator,bool> synfig::ValueNode_Animated::findresult

typedef std::pair<WaypointList::const_iterator,bool> synfig::ValueNode_Animated::const_findresult

## Constructor & Destructor Documentation

ValueNode_Animated::~ValueNode_Animated | ( |  | ) | `[virtual]`

ValueNode_Animated::ValueNode_Animated | ( |  | ) | `[protected]`

References DCAST_HACK_ENABLE.

## Member Function Documentation

WaypointList& synfig::ValueNode_Animated::waypoint_list | ( |  | ) | `[inline]`

References waypoint_list_.

Referenced by erase(), find(), find_next(), find_prev(), get_times_vfunc(), insert_time(), and new_waypoint_at_time().

const WaypointList& synfig::ValueNode_Animated::waypoint_list | ( |  | ) | const`[inline]`

References waypoint_list_.

virtual WaypointList::iterator synfig::ValueNode_Animated::new_waypoint | ( | Time | t,
|  | ValueBase | value |
| ) |  |  | `[pure virtual]`

virtual WaypointList::iterator synfig::ValueNode_Animated::new_waypoint | ( | Time | t,
|  | ValueNode::Handle | value_node |
| ) |  |  | `[pure virtual]`

Waypoint ValueNode_Animated::new_waypoint_at_time | ( | const Time & | t | ) | const

Note:
  this does not add any waypoint to the ValueNode!

References find(), find_next(), find_prev(), synfig::UniqueID::make_unique(), synfig::Waypoint::set_parent_value_node(), synfig::Waypoint::set_time(), synfig::Waypoint::set_value(), synfig::Waypoint::set_value_node(), and waypoint_list().

ValueNode_Animated::WaypointList::iterator ValueNode_Animated::add | ( | const Waypoint & | x | ) |

References synfig::Node::changed(), synfig::Waypoint::set_parent_value_node(), and waypoint_list_.

void ValueNode_Animated::erase | ( | const UniqueID & | x | ) |

References find(), and waypoint_list().

ValueNode_Animated::findresult ValueNode_Animated::find_uid | ( | const UniqueID & | x | ) |

References f, and waypoint_list_.

ValueNode_Animated::const_findresult ValueNode_Animated::find_uid | ( | const UniqueID & | x | ) | const

References f, and waypoint_list_.

ValueNode_Animated::findresult ValueNode_Animated::find_time | ( | const Time & | x | ) |

References f, and waypoint_list_.

ValueNode_Animated::const_findresult ValueNode_Animated::find_time | ( | const Time & | x | ) | const

References f, and waypoint_list_.

ValueNode_Animated::WaypointList::iterator ValueNode_Animated::find | ( | const UniqueID & | x | ) |

References synfig::UniqueID::get_uid(), and waypoint_list().

Referenced by erase(), find(), and new_waypoint_at_time().

ValueNode_Animated::WaypointList::const_iterator ValueNode_Animated::find | ( | const UniqueID & | x | ) | const

References find().

ValueNode_Animated::WaypointList::iterator ValueNode_Animated::find | ( | const Time & | x | ) |

References synfig::Time::get_string(), synfig::Time::is_equal(), and waypoint_list().

ValueNode_Animated::WaypointList::const_iterator ValueNode_Animated::find | ( | const Time & | x | ) | const

References find().

ValueNode_Animated::WaypointList::iterator ValueNode_Animated::find_next | ( | const Time & | x | ) |

References synfig::Time::get_string(), and waypoint_list().

Referenced by find(), find_next(), insert_time(), and new_waypoint_at_time().

ValueNode_Animated::WaypointList::const_iterator ValueNode_Animated::find_next | ( | const Time & | x | ) | const

References find_next().

ValueNode_Animated::WaypointList::iterator ValueNode_Animated::find_prev | ( | const Time & | x | ) |

References synfig::Time::get_string(), and waypoint_list().

Referenced by find_prev(), and new_waypoint_at_time().

ValueNode_Animated::WaypointList::const_iterator ValueNode_Animated::find_prev | ( | const Time & | x | ) | const

References find_prev().

String ValueNode_Animated::get_name | ( |  | ) | const`[virtual]`

Returns the name of the ValueNode type.

Implements synfig::ValueNode.

String ValueNode_Animated::get_local_name | ( |  | ) | const`[virtual]`

Returns the localized name of the ValueNode type.

Implements synfig::ValueNode.

References _.

ValueNode_Animated::Handle synfig::ValueNode_Animated::create | ( | ValueBase::Type | type | ) | `[static]`

References _, synfig::ValueBase::TYPE_ANGLE, synfig::ValueBase::TYPE_BOOL, synfig::ValueBase::TYPE_CANVAS, synfig::ValueBase::TYPE_COLOR, synfig::ValueBase::TYPE_GRADIENT, synfig::ValueBase::TYPE_INTEGER, synfig::ValueBase::type_local_name(), synfig::ValueBase::TYPE_REAL, synfig::ValueBase::TYPE_STRING, synfig::ValueBase::TYPE_TIME, and synfig::ValueBase::TYPE_VECTOR.

Referenced by create().

ValueNode_Animated::Handle ValueNode_Animated::create | ( | const ValueBase & | value,
|  | const Time & | time |
| ) |  |  | `[static]`

References synfig::ValueNode_Const::create(), and create().

ValueNode_Animated::Handle ValueNode_Animated::create | ( | ValueNode::Handle | value_node,
|  | const Time & | time |
| ) |  |  | `[static]`

References create().

int ValueNode_Animated::find | ( | const Time & | begin,
|  | const Time & | end,
|  | std::vector< Waypoint * > & | list |
| ) |  |  |

References find(), and find_next().

void ValueNode_Animated::insert_time | ( | const Time & | location,
|  | const Time & | delta |
| ) |  |  |

References synfig::Node::changed(), find_next(), and waypoint_list().

void ValueNode_Animated::set_type | ( | ValueBase::Type | t | ) | `[protected]`

Sets the type of the ValueNode.

Reimplemented from synfig::ValueNode.

References synfig::ValueNode::set_type().

void ValueNode_Animated::get_times_vfunc | ( | Node::time_set & | set | ) | const`[protected, virtual]`

Function to be overloaded that fills

Implements synfig::Node.

References synfig::TimePoint::set_after(), synfig::TimePoint::set_before(), synfig::TimePoint::set_guid(), synfig::TimePoint::set_time(), and waypoint_list().

synfig::ValueNode_Animated::DCAST_HACK_ID | ( | 4 |  | ) |

## Member Data Documentation

WaypointList synfig::ValueNode_Animated::waypoint_list_ `[protected]`

Referenced by add(), find_time(), find_uid(), and waypoint_list().

The documentation for this struct was generated from the following files:

- valuenode_animated.h
- valuenode_animated.cpp